C program
C

*     corelplot.f

*     This program plots a possible source region as calculated by locate_multi.f

*     Original Author contact information:

*     Gerhard Wotawa
*     Gerhard Wotawa@zamg.ac.at

*     Christian Maurer
*     christian.maurer@zamg.ac.at

*     Disclaimer:

*     This software is presented freely to the public with
*     no restrictions on its use.  However, it would be
*     appreciated if any use of the software or methods in
*     part or in full acknowledges the source.
*     No liabilty taken by developers.

      implicit none

      integer icont
      parameter(icont=7)
      integer idomain,ibdate,ibtime,iedate,ietime,is
      integer nhourssum,idhours1,idhours2,it,ntmax,nxout,nyout,ntmax1
      integer idum,indx,indy,ix,jy,iymds,ihmss,iymd,ihms
      integer iproject,lind,istatplot,nums,ip,nump
      real xlon1,xlon2,ylat1,ylat2,corrgrid2dmax
      real xmass,dxout,dyout,rdum,outlon0,outlat0
      real xlonext,ylatext,duration,zmin,zmax,delz,zcount
      !parameter(delz=0.05)
      parameter(delz=0.1)
      real xlonp,ylatp,value,corrmax,corrmin,corrmin1
      real xlonmin,xlonmax,ylatmin,ylatmax,xlongrid,ylatgrid,domaindilut
      character*300 corrfile,pcomment,userx,installdir,pcom,species
      character*300 statfile,cmd
      character*7 ltext(icont)
      character*15 datetime
      character*19 clist(icont)
      real, dimension(:, :, :), ALLOCATABLE :: corrgrid
      real, dimension(:, :), ALLOCATABLE :: corrgrid2d
      real, dimension(:), ALLOCATABLE :: xlons,ylats
      real, dimension(:), ALLOCATABLE :: xpoint,ypoint
      character*5, dimension(:), ALLOCATABLE :: statid
      integer, dimension(:), ALLOCATABLE :: imarks
      double precision juldate,juls,jul

      clist(7)='RGB(0.75,0.00,0.50)'
      clist(6)='RGB(1.00,0.00,0.50)'
      clist(5)='RGB(0.90,0.60,0.10)'
      clist(4)='RGB(0.80,0.80,0.30)'
      clist(3)='RGB(0.00,0.90,0.90)'
      clist(2)='RGB(0.00,0.50,0.75)'
      clist(1)='RGB(0.50,0.00,0.50)'

      call getlog (userx)
      call getenv ("PWD", installdir)
      open(10,file='CONTROL',status='old',err=999)
      read(10,'(a)',end=999,err=999) corrfile
      read(10,'(a)',end=999,err=999) pcomment
      read(10,*,end=999,err=999) duration
      read(10,*,end=999,err=999) iproject
      read(10,*,end=999,err=999) istatplot
      read(10,'(a)',end=999,err=999) statfile
      read(10,*,end=999,err=999) idomain
      read(10,*,end=999,err=999) domaindilut,xlonext,ylatext
      read(10,*,end=999,err=999) xlon1,xlon2,ylat1,ylat2
      close(10)


* If Station locations are to be plotted: Read in station file in CTBTO format

      if(istatplot.eq.1) then
        open(10,file=trim(statfile),status='old',err=997)
        read(10,*) nums
        allocate(xlons(nums))
        allocate(ylats(nums))
        allocate(statid(nums))
        allocate(imarks(nums))
        do is=1,nums
          read(10,'(2f9.4,1x,a)',end=997,err=997) xlons(is),ylats(is),
     &      statid(is)
          imarks(is)=15
        enddo
        close(10)


       endif

* Read in Correlation file header information

      open(10,file=trim(corrfile),status='old',err=998)
      read(10,*,end=998,err=998) rdum,rdum,ibdate,ibtime,iedate,
     &  ietime,xmass,nhourssum,idhours1,idhours2,dxout,dyout
     &  ,outlon0,outlat0,nxout,nyout,species
      write(*,*) outlon0,outlat0,nxout,nyout
      read(10,*,end=998,err=998) nump
      allocate(xpoint(nump))
      allocate(ypoint(nump))
      do ip=1,nump
        read(10,*,end=998,err=998) xpoint(ip),ypoint(ip)
      enddo
      read(10,*,end=10) rdum,rdum,it,rdum
      close(10)

      pcom=trim(pcomment)
      iymds=ibdate
      ihmss=ibtime*10000
      juls=juldate(iymds,ihmss) 
      ntmax=nhourssum/idhours1
*      outlon0=-180.0+dxout
*      outlat0=-90.0
*      nxout=-2*int((outlon0-dxout)/dxout)
*      nyout=-2*int(outlat0/dyout)
      print *, ntmax,outlon0,outlat0,nxout,nyout
      allocate (corrgrid(nxout, nyout, ntmax))
      allocate (corrgrid2d(nxout, nyout))

      corrgrid=1.e-30
      corrgrid2d=1.e-30
      
* Read in Correlation file data from file

      open(10,file=trim(corrfile),status='old',err=998)
      read(10,*,end=998,err=998)
      read(10,*,end=998,err=998) nump
      do ip=1,nump
        read(10,*,end=998,err=998)
      enddo

      idum=1
      corrmax=0.0
      corrmin1=1.e30
      do while(idum /= 0)
        read(10,*,end=10,err=998) ylatp,xlonp,it,value
        indx=int((xlonp+0.5*dxout-outlon0)/dxout)+1
        indy=int((ylatp+0.5*dyout-outlat0)/dyout)+1
        corrgrid(indx,indy,it)=value
        if(corrgrid(indx,indy,it).gt.corrmax) 
     &    corrmax=corrgrid(indx,indy,it)
        if(corrgrid(indx,indy,it).lt.corrmin1) 
     &    corrmin1=corrgrid(indx,indy,it)
      enddo
10    close(10)
      corrmin=corrmax/domaindilut
      if(corrmax.eq.0.0) then
        write(*,'(a)') "Routine corelplot:"
        write(*,'(a)') "Correlation field contains no data"
        stop
      endif

!     zmax=float(int(corrmax*10.0)+2)/10.0
!     zmax = 0.5
      zmax=1.0
      zmin=zmax-float(icont)*delz
      if(zmax.lt.0.8) zmax=0.8
      zcount=zmax
      do lind=icont,1,-1
        ltext(lind)='   -   '
        write(ltext(lind)(1:3),'(f3.1)') zcount-delz
        write(ltext(lind)(5:7),'(f3.1)') zcount
        WRITE(*,*) LIND," ",LTEXT(LIND)
        zcount=zcount-delz
      enddo

      WRITE(*,*) corrmin1,corrmin,corrmax
      WRITE(*,*) ZMIN,ZMAX,DELZ

      ntmax1=min(ntmax,int(duration/float(idhours1)))

*
* Now, compute domain and isolines
*
      if(idomain.ne.1) then
        xlonmin=1.e30
        ylatmin=1.e30
        xlonmax=-1.e30
        ylatmax=-1.e30
        do ix=1,nxout
          do jy=1,nyout
            do it=1,ntmax1
              if(corrgrid(ix,jy,it).gt.corrmin) then
                  xlongrid=outlon0+float(ix-1)*dxout
                  ylatgrid=outlat0+float(jy-1)*dyout
                  if(xlongrid.gt.xlonmax) xlonmax=xlongrid
                  if(xlongrid.lt.xlonmin) xlonmin=xlongrid
                  if(ylatgrid.gt.ylatmax) ylatmax=ylatgrid
                  if(ylatgrid.lt.ylatmin) ylatmin=ylatgrid
              endif
            enddo
          enddo
        enddo
      endif
 
      if(idomain.ne.1) then
        xlon1=xlonmin-xlonext
        xlon2=xlonmax+xlonext
        ylat1=ylatmin-ylatext
        ylat2=ylatmax+ylatext
      else
      endif

      if(xlon1.lt.-180.0) xlon1=-180.0
      if(xlon2.gt.+180.0) xlon2=+180.0
      if(ylat1.lt. -90.0) ylat1= -90.0
      if(ylat2.gt. +90.0) ylat2= +90.0

      CALL POPEN
      CALL PSETC('PAGE_ID_LINE', 'OFF')

      if(iproject.eq.1) then
        call psetc ('SUBPAGE_MAP_PROJECTION', 'CYLINDRICAL')
        call PSETR('SUBPAGE_LOWER_LEFT_LONGITUDE', xlon1)
        call psetr('SUBPAGE_UPPER_RIGHT_LONGITUDE',xlon2)
        call psetr('SUBPAGE_LOWER_LEFT_LATITUDE',ylat1)
        call psetr('SUBPAGE_UPPER_RIGHT_LATITUDE',ylat2)
      else
        call psetc ('SUBPAGE_MAP_PROJECTION', 'MERCATOR')
        call PSETR('SUBPAGE_LOWER_LEFT_LONGITUDE', xlon1)
        call psetr('SUBPAGE_UPPER_RIGHT_LONGITUDE',xlon2)
        call psetr('SUBPAGE_LOWER_LEFT_LATITUDE',ylat1)
        call psetr('SUBPAGE_UPPER_RIGHT_LATITUDE',ylat2)
      endif

      write(*,*) xlon1,xlon2,ylat1,ylat2,dxout,dyout

      CALL PSETC ('OUTPUT_FORMAT', 'PS')
      CALL PSETC ('OUTPUT_NAME', 'ps_plot')

      call psetc('INPUT_FIELD_ORGANIZATION','REGULAR')
      call PSETR('INPUT_FIELD_INITIAL_LONGITUDE',outlon0)
      call PSETR('INPUT_FIELD_INITIAL_LATITUDE',outlat0)


      CALL PSETC ('MAP_COASTLINE_COLOUR', 'BLACK')
      CALL PSETC ('map_coastline_resolution', 'AUTOMATIC')
      CALL PSETC ('map_boundaries','ON')
      CALL PSETC ('MAP_BOUNDARIES_COLOUR', 'BLACK')
      CALL PSETI ('map_boundaries_thickness', 2)
      CALL PSETC ('MAP_GRID_COLOUR', 'BLACK')
      call psetc ('map_coastline_land_shade', 'ON')
      call psetc ('map_coastline_land_shade_colour',
     + 'RGB(0.5, 0.6,0.5)')
      call psetc ('map_coastline_sea_shade', 'ON')
      call psetc ('map_coastline_sea_shade_colour',
     + 'RGB(0.9, 0.9,1.0)')

      CALL PSETC ('CONTOUR_METHOD', 'AUTOMATIC')
      
      CALL PSETC ('CONTOUR_LINE_STYLE', 'SOLID')
      CALL PSETC ('CONTOUR_LINE_COLOUR', 'BLACK')
      CALL PSETC ('CONTOUR_SHADE', 'ON')
      CALL PSETC ('contour_shade_technique', 'POLYGON_SHADING')
      CALL PSETC ('contour_shade_method','AREA_FILL')
      CALL PSETI ('contour_level_count', icont)
      CALL PSETC ('CONTOUR_LEVEL_SELECTION_TYPE', 'INTERVAL')
      CALL PSETC ('CONTOUR_LABEL', 'OFF')
      CALL PSETR ('contour_shade_min_level',zmin)
      CALL PSETR ('contour_shade_max_level',zmax)
      CALL PSETR ('CONTOUR_REFERENCE_LEVEL', zmin)
      CALL PSETR ('CONTOUR_INTERVAL', delz)
      CALL PSETC ('CONTOUR_SHADE_COLOUR_METHOD', 'LIST')
      CALL PSET1C('CONTOUR_SHADE_COLOUR_LIST',CLIST,ICONT)

      CALL PSETI ('TEXT_LINE_COUNT', 3)
      CALL PSETC ('TEXT_LINE_1', pcom)
      CALL PSETC ('LEGEND', 'ON')
      CALL PSETC ('LEGEND_TITLE', 'OFF')
      CALL PSETC ('legend_border', 'ON')
      CALL PSETI ('LEGEND_COLUMN_COUNT', 1)
      CALL PSETC ('LEGEND_ENTRY_PLOT_DIRECTION','ROW')
      CALL PSETR ('legend_box_y_length', 3.0) 
      CALL PSETR ('legend_text_font_size', 0.17) 
      CALL PSETC ('legend_user_text_1', ltext(1))
      CALL PSETC ('legend_user_text_2', ltext(2))
      CALL PSETC ('legend_user_text_3', ltext(3))
      CALL PSETC ('legend_user_text_4', ltext(4))
      CALL PSETC ('legend_user_text_5', ltext(5))
      CALL PSETC ('legend_user_text_6', ltext(6))
      CALL PSETC ('legend_user_text_7', ltext(7))


      do it=1,ntmax1
        jul=juls-dble(float(it*idhours1)/24.0)
        call caldate(jul,iymd,ihms)
        write(datetime(1:8),'(i8.8)') iymd
        datetime(9:9)='-'
        write(datetime(10:15),'(i6.6)') ihms
        corrgrid2dmax=0.0
        do jy=1,nyout
          do ix=1,nxout
            corrgrid2d(ix,jy)=corrgrid(ix,jy,it)
            if(corrgrid2d(ix,jy).gt.corrgrid2dmax) then
               corrgrid2dmax=corrgrid2d(ix,jy)
            endif
          enddo
        enddo

       if(corrgrid2dmax.ge.0.1) then  ! C. Maurer, 29160324: relaxed, since low correlations when not including "non-detections" are skipped!
        WRITE(*,*) it,iymd,ihms


        call PSETR('INPUT_FIELD_LONGITUDE_STEP',dxout)
        call PSETR('INPUT_FIELD_LATITUDE_STEP',dyout)
        CALL PSET2R ('INPUT_FIELD',corrgrid2d,nxout,nyout)

        CALL PCOAST
        CALL PSETC ('LEGEND', 'ON')
        CALL PCONT
        CALL PSETC ('LEGEND', 'OFF')
        CALL PSETC ('TEXT_LINE_2', datetime)

        CALL PSETC ('TEXT_LINE_3','Correlation Field')
        CALL PTEXT

        CALL PSETR ('symbol_text_font_size', 0.5)
        CALL PSETC ('symbol_text_font_style', 'BOLD')
        CALL PSETC ('SYMBOL_TYPE','MARKER')
        CALL PSETC ('SYMBOL_COLOUR', 'BLACK')
        CALL PSETR ('SYMBOL_HEIGHT', 0.5)
        CALL PSETI ('SYMBOL_MARKER_INDEX',15)
! 
        do ip=1,nump
         CALL PSET1R ('SYMBOL_INPUT_X_POSITION',xpoint(ip),1)
         CALL PSET1R ('SYMBOL_INPUT_Y_POSITION',ypoint(ip),1)
         CALL PSET1C ('SYMBOL_TEXT_LIST','',1)
         CALL PSYMB
        enddo

    
        if(istatplot.eq.1) then
         do is=1,nums
          CALL PSET1R ('SYMBOL_INPUT_X_POSITION',xlons(is),1)
          CALL PSET1R ('SYMBOL_INPUT_Y_POSITION',ylats(is),1)
          CALL PSET1C ('SYMBOL_TEXT_LIST',statid(is),1)
          CALL PSYMB
         enddo
        endif


        CALL PSETC ('SYMBOL_TYPE','TEXT')

        call PNEW('PAGE')

      endif

      enddo

      CALL PCLOSE

* Clean up

* Convert postscript to gif

*      write(*,'(a)') "Convert output to animated gif"
*      call system('convert -rotate 90 ps_plot.ps ps_plot.gif')
      write(*,'(a)') "Convert output to animated gif"
      call system('convert -rotate 90 ps_plot.ps ps_plot.gif')
      cmd="convert ps_plot.gif -coalesce -gravity SouthWest "//
     &    "ps_plot.gif"
      call system(trim(cmd))

      stop "Finished Routine corelplot"

997   write(*,'(a)') "FAILURE ROUTINE corelplot"
      write(*,'(a)') "File "//trim(statfile)// " was not found"//
     & " in local directory"
      write(*,'(a)') "or is corrupt"
      call exit(-2)
998   write(*,'(a)') "FAILURE ROUTINE corelplot"
      write(*,'(a)') "File "//trim(corrfile)// " was not found"//
     & " in local directory"
      write(*,'(a)') "or is corrupt"
      call exit(-2)
999   write(*,'(a)') "FAILURE ROUTINE corelplot"
      write(*,'(a)') "File CONTROL was not found in local directory"
      write(*,'(a)') "or is corrupt"
      call exit(-2)

      end
